Index: /palm/trunk/SOURCE/diffusivities.f90
===================================================================
--- /palm/trunk/SOURCE/diffusivities.f90	(revision 1339)
+++ /palm/trunk/SOURCE/diffusivities.f90	(revision 1340)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! REAL constants defined as wp-kind
 !
 ! Former revisions:
@@ -99,5 +99,5 @@
 !
 !-- Initialization for calculation of the mixing length profile
-    sums_l_l = 0.0
+    sums_l_l = 0.0_wp
 
 !
@@ -113,5 +113,5 @@
 !
 !-- Introduce an optional minimum tke
-    IF ( e_min > 0.0 )  THEN
+    IF ( e_min > 0.0_wp )  THEN
        !$OMP DO
        !$acc loop
@@ -142,11 +142,11 @@
                 dvar_dz = atmos_ocean_sign * &  ! inverse effect of pt/rho gradient
                           ( var(k+1,j,i) - var(k-1,j,i) ) * dd2zu(k)
-                IF ( dvar_dz > 0.0 ) THEN
+                IF ( dvar_dz > 0.0_wp ) THEN
                    IF ( use_single_reference_value )  THEN
                       l_stable = 0.76_wp * sqrt_e /                            &
-                                 SQRT( g / var_reference * dvar_dz ) + 1E-5_wp
+                                    SQRT( g / var_reference * dvar_dz ) + 1E-5_wp
                    ELSE
                       l_stable = 0.76_wp * sqrt_e /                            &
-                                 SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5_wp
+                                    SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5_wp
                    ENDIF
                 ELSE
Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 1339)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 1340)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-!
+! REAL constants defined as wp-kind
 !
 ! Former revisions:
@@ -441,5 +441,5 @@
        IF ( humidity_remote )  THEN
           ALLOCATE( qswst_remote(nysg:nyng,nxlg:nxrg))
-          qswst_remote = 0.0
+          qswst_remote = 0.0_wp
        ENDIF
     ENDIF
@@ -453,9 +453,9 @@
     ENDIF
 
-    IF ( dt_dosp /= 9999999.9 )  THEN
+    IF ( dt_dosp /= 9999999.9_wp )  THEN
        ALLOCATE( spectrum_x( 1:nx/2, 1:10, 1:10 ), &
                  spectrum_y( 1:ny/2, 1:10, 1:10 ) )
-       spectrum_x = 0.0
-       spectrum_y = 0.0
+       spectrum_x = 0.0_wp
+       spectrum_y = 0.0_wp
     ENDIF
 
@@ -463,5 +463,5 @@
 !-- 1D-array for large scale subsidence velocity
     ALLOCATE ( w_subs(nzb:nzt+1) )
-    w_subs = 0.0
+    w_subs = 0.0_wp
 
 
@@ -480,5 +480,5 @@
        ENDIF
 
-       IF ( cthf /= 0.0 ) THEN
+       IF ( cthf /= 0.0_wp ) THEN
           ALLOCATE ( lai(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
                      canopy_heat_flux(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
@@ -491,5 +491,5 @@
     IF ( topography /= 'flat' )  THEN
        ALLOCATE( rif_wall(nzb:nzt+1,nysg:nyng,nxlg:nxrg,1:4) )
-       rif_wall = 0.0
+       rif_wall = 0.0_wp
     ENDIF
 
@@ -578,6 +578,6 @@
     ALLOCATE( weight_substep(1:intermediate_timestep_count_max), &
               weight_pres(1:intermediate_timestep_count_max) )
-    weight_substep = 1.0
-    weight_pres    = 1.0
+    weight_substep = 1.0_wp
+    weight_pres    = 1.0_wp
     intermediate_timestep_count = 1  ! needed when simulated_time = 0.0
        
@@ -617,6 +617,6 @@
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
-                      qr(:,j,i) = 0.0
-                      nr(:,j,i) = 0.0
+                      qr(:,j,i) = 0.0_wp
+                      nr(:,j,i) = 0.0_wp
                    ENDDO
                 ENDDO
@@ -640,24 +640,24 @@
              IF ( prandtl_layer )  THEN
                 rif  = rif1d(nzb+1)
-                ts   = 0.0  ! could actually be computed more accurately in the
-                            ! 1D model. Update when opportunity arises.
+                ts   = 0.0_wp  ! could actually be computed more accurately in the
+                               ! 1D model. Update when opportunity arises.
                 us   = us1d
                 usws = usws1d
                 vsws = vsws1d
              ELSE
-                ts   = 0.0  ! must be set, because used in
-                rif  = 0.0  ! flowste
-                us   = 0.0
-                usws = 0.0
-                vsws = 0.0
+                ts   = 0.0_wp  ! must be set, because used in
+                rif  = 0.0_wp  ! flowste
+                us   = 0.0_wp
+                usws = 0.0_wp
+                vsws = 0.0_wp
              ENDIF
 
           ELSE
-             e    = 0.0  ! must be set, because used in
-             rif  = 0.0  ! flowste
-             ts   = 0.0
-             us   = 0.0
-             usws = 0.0
-             vsws = 0.0
+             e    = 0.0_wp  ! must be set, because used in
+             rif  = 0.0_wp  ! flowste
+             ts   = 0.0_wp
+             us   = 0.0_wp
+             usws = 0.0_wp
+             vsws = 0.0_wp
           ENDIF
           uswst = top_momentumflux_u
@@ -669,9 +669,9 @@
 !--       Update when opportunity arises!
           IF ( humidity  .OR.  passive_scalar )  THEN
-             qs = 0.0
+             qs = 0.0_wp
              IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
                   precipitation )  THEN
-                qrs = 0.0
-                nrs = 0.0
+                qrs = 0.0_wp
+                nrs = 0.0_wp
              ENDIF
           ENDIF
@@ -682,6 +682,6 @@
              DO  i = nxl-1, nxr+1
                 DO  j = nys-1, nyn+1
-                   u(nzb:nzb_u_inner(j,i),j,i) = 0.0
-                   v(nzb:nzb_v_inner(j,i),j,i) = 0.0
+                   u(nzb:nzb_u_inner(j,i),j,i) = 0.0_wp
+                   v(nzb:nzb_v_inner(j,i),j,i) = 0.0_wp
                 ENDDO
              ENDDO
@@ -745,6 +745,6 @@
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
-                u(nzb:nzb_u_inner(j,i)+1,j,i) = 0.0
-                v(nzb:nzb_v_inner(j,i)+1,j,i) = 0.0
+                u(nzb:nzb_u_inner(j,i)+1,j,i) = 0.0_wp
+                v(nzb:nzb_v_inner(j,i)+1,j,i) = 0.0_wp
              ENDDO
           ENDDO
@@ -764,6 +764,6 @@
                    DO  i = nxlg, nxrg
                       DO  j = nysg, nyng
-                         qr(:,j,i) = 0.0
-                         nr(:,j,i) = 0.0
+                         qr(:,j,i) = 0.0_wp
+                         nr(:,j,i) = 0.0_wp
                       ENDDO
                    ENDDO
@@ -784,8 +784,8 @@
              km   = km_constant
              kh   = km / prandtl_number
-             e    = 0.0
-          ELSEIF ( e_init > 0.0 )  THEN
+             e    = 0.0_wp
+          ELSEIF ( e_init > 0.0_wp )  THEN
              DO  k = nzb+1, nzt
-                km(k,:,:) = 0.1 * l_grid(k) * SQRT( e_init )
+                km(k,:,:) = 0.1_wp * l_grid(k) * SQRT( e_init )
              ENDDO
              km(nzb,:,:)   = km(nzb+1,:,:)
@@ -795,22 +795,22 @@
           ELSE
              IF ( .NOT. ocean )  THEN
-                kh   = 0.01   ! there must exist an initial diffusion, because 
-                km   = 0.01   ! otherwise no TKE would be produced by the
+                kh   = 0.01_wp   ! there must exist an initial diffusion, because 
+                km   = 0.01_wp   ! otherwise no TKE would be produced by the
                               ! production terms, as long as not yet
                               ! e = (u*/cm)**2 at k=nzb+1
              ELSE
-                kh   = 0.00001
-                km   = 0.00001
-             ENDIF
-             e    = 0.0
-          ENDIF
-          rif   = 0.0
-          ts    = 0.0
-          us    = 0.0
-          usws  = 0.0
+                kh   = 0.00001_wp
+                km   = 0.00001_wp
+             ENDIF
+             e    = 0.0_wp
+          ENDIF
+          rif   = 0.0_wp
+          ts    = 0.0_wp
+          us    = 0.0_wp
+          usws  = 0.0_wp
           uswst = top_momentumflux_u
-          vsws  = 0.0
+          vsws  = 0.0_wp
           vswst = top_momentumflux_v
-          IF ( humidity  .OR.  passive_scalar ) qs = 0.0
+          IF ( humidity  .OR.  passive_scalar ) qs = 0.0_wp
 
 !
@@ -829,6 +829,6 @@
 !--    Bottom boundary
        IF ( ibc_uv_b == 0 .OR. ibc_uv_b == 2  )  THEN
-          u(nzb,:,:) = 0.0
-          v(nzb,:,:) = 0.0
+          u(nzb,:,:) = 0.0_wp
+          v(nzb,:,:) = 0.0_wp
        ENDIF
 
@@ -836,11 +836,11 @@
 !--    Apply channel flow boundary condition
        IF ( TRIM( bc_uv_t ) == 'dirichlet_0' )  THEN
-          u(nzt+1,:,:) = 0.0
-          v(nzt+1,:,:) = 0.0
+          u(nzt+1,:,:) = 0.0_wp
+          v(nzt+1,:,:) = 0.0_wp
        ENDIF
 
 !
 !--    Calculate virtual potential temperature
-       IF ( humidity ) vpt = pt * ( 1.0 + 0.61 * q )
+       IF ( humidity ) vpt = pt * ( 1.0_wp + 0.61_wp * q )
 
 !
@@ -849,6 +849,6 @@
        hom(:,1,6,:) = SPREAD( v(:,nys,nxl), 2, statistic_regions+1 )
        IF ( ibc_uv_b == 0 .OR. ibc_uv_b == 2)  THEN
-          hom(nzb,1,5,:) = 0.0   
-          hom(nzb,1,6,:) = 0.0  
+          hom(nzb,1,5,:) = 0.0_wp
+          hom(nzb,1,6,:) = 0.0_wp
        ENDIF
        hom(:,1,7,:)  = SPREAD( pt(:,nys,nxl), 2, statistic_regions+1 )
@@ -919,6 +919,6 @@
              IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
                   precipitation )  THEN
-                qrsws = 0.0
-                nrsws = 0.0
+                qrsws = 0.0_wp
+                nrsws = 0.0_wp
              ENDIF
              IF ( constant_waterflux )  THEN
@@ -954,9 +954,9 @@
 
              IF ( humidity  .OR.  passive_scalar )  THEN
-                qswst = 0.0
+                qswst = 0.0_wp
                 IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
                      precipitation ) THEN
-                   nrswst = 0.0
-                   qrswst = 0.0
+                   nrswst = 0.0_wp
+                   qrswst = 0.0_wp
                 ENDIF
              ENDIF
@@ -971,5 +971,5 @@
 !--       Initialization in case of a coupled model run
           IF ( coupling_mode == 'ocean_to_atmosphere' )  THEN
-             tswst = 0.0
+             tswst = 0.0_wp
           ENDIF
 
@@ -990,13 +990,13 @@
 !--          to be zero before the first time step. It approaches its correct
 !--          value in the course of the first few time steps.
-             shf   = 0.0
+             shf   = 0.0_wp
           ENDIF
 
           IF ( humidity  .OR.  passive_scalar )  THEN
-             IF ( .NOT. constant_waterflux )  qsws   = 0.0
+             IF ( .NOT. constant_waterflux )  qsws   = 0.0_wp
              IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
                   precipitation )  THEN
-                qrsws = 0.0
-                nrsws = 0.0
+                qrsws = 0.0_wp
+                nrsws = 0.0_wp
              ENDIF
           ENDIF
@@ -1023,13 +1023,13 @@
 !
 !--    For the moment, vertical velocity is zero
-       w = 0.0
+       w = 0.0_wp
 
 !
 !--    Initialize array sums (must be defined in first call of pres)
-       sums = 0.0
+       sums = 0.0_wp
 
 !
 !--    In case of iterative solvers, p must get an initial value
-       IF ( psolver == 'multigrid'  .OR.  psolver == 'sor' )  p = 0.0
+       IF ( psolver == 'multigrid'  .OR.  psolver == 'sor' )  p = 0.0_wp
 
 !
@@ -1037,8 +1037,8 @@
 !--    are zero at beginning of the simulation
        IF ( cloud_physics )  THEN
-          ql = 0.0
-          IF ( precipitation )  precipitation_amount = 0.0
+          ql = 0.0_wp
+          IF ( precipitation )  precipitation_amount = 0.0_wp
           IF ( icloud_scheme == 0 )  THEN
-             qc = 0.0
+             qc = 0.0_wp
              nc_1d = nc_const
           ENDIF 
@@ -1058,5 +1058,5 @@
 !
 !--    If required, change the surface temperature at the start of the 3D run
-       IF ( pt_surface_initial_change /= 0.0 )  THEN
+       IF ( pt_surface_initial_change /= 0.0_wp )  THEN
           pt(nzb,:,:) = pt(nzb,:,:) + pt_surface_initial_change
        ENDIF
@@ -1066,5 +1066,5 @@
 !--    run
        IF ( ( humidity .OR. passive_scalar ) .AND. &
-            q_surface_initial_change /= 0.0 )  THEN
+            q_surface_initial_change /= 0.0_wp )  THEN
           q(nzb,:,:) = q(nzb,:,:) + q_surface_initial_change
        ENDIF
@@ -1075,15 +1075,15 @@
 !
 !--    Initialize old and new time levels.
-       te_m = 0.0; tpt_m = 0.0; tu_m = 0.0; tv_m = 0.0; tw_m = 0.0
+       te_m = 0.0_wp; tpt_m = 0.0_wp; tu_m = 0.0_wp; tv_m = 0.0_wp; tw_m = 0.0_wp
        e_p = e; pt_p = pt; u_p = u; v_p = v; w_p = w
 
        IF ( humidity  .OR.  passive_scalar )  THEN
-          tq_m = 0.0
+          tq_m = 0.0_wp
           q_p = q
           IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
                precipitation )  THEN
-             tqr_m = 0.0
+             tqr_m = 0.0_wp
              qr_p = qr
-             tnr_m = 0.0
+             tnr_m = 0.0_wp
              nr_p = nr
           ENDIF
@@ -1091,5 +1091,5 @@
 
        IF ( ocean )  THEN
-          tsa_m = 0.0
+          tsa_m = 0.0_wp
           sa_p  = sa
        ENDIF
@@ -1171,5 +1171,5 @@
                    u(k,j,nxlg:-1)  = mean_inflow_profiles(k,1)
                    v(k,j,nxlg:-1)  = mean_inflow_profiles(k,2)
-                   w(k,j,nxlg:-1)  = 0.0
+                   w(k,j,nxlg:-1)  = 0.0_wp
                    pt(k,j,nxlg:-1) = mean_inflow_profiles(k,4)
                    e(k,j,nxlg:-1)  = mean_inflow_profiles(k,5)
@@ -1183,10 +1183,10 @@
 !--       vertically because otherwise the turbulent inflow layer will grow
 !--       in time.
-          IF ( inflow_damping_height == 9999999.9 )  THEN
+          IF ( inflow_damping_height == 9999999.9_wp )  THEN
 !
 !--          Default: use the inversion height calculated by the prerun; if
 !--          this is zero, inflow_damping_height must be explicitly
 !--          specified.
-             IF ( hom_sum(nzb+6,pr_palm,0) /= 0.0 )  THEN
+             IF ( hom_sum(nzb+6,pr_palm,0) /= 0.0_wp )  THEN
                 inflow_damping_height = hom_sum(nzb+6,pr_palm,0)
              ELSE
@@ -1199,9 +1199,9 @@
           ENDIF
 
-          IF ( inflow_damping_width == 9999999.9 )  THEN
+          IF ( inflow_damping_width == 9999999.9_wp )  THEN
 !
 !--          Default for the transition range: one tenth of the undamped
 !--          layer
-             inflow_damping_width = 0.1 * inflow_damping_height
+             inflow_damping_width = 0.1_wp * inflow_damping_height
 
           ENDIF
@@ -1212,11 +1212,11 @@
 
              IF ( zu(k) <= inflow_damping_height )  THEN
-                inflow_damping_factor(k) = 1.0
+                inflow_damping_factor(k) = 1.0_wp
              ELSEIF ( zu(k) <= ( inflow_damping_height + inflow_damping_width ) )  THEN
-                inflow_damping_factor(k) = 1.0 -                               &
+                inflow_damping_factor(k) = 1.0_wp -                            &
                                            ( zu(k) - inflow_damping_height ) / &
                                            inflow_damping_width
              ELSE
-                inflow_damping_factor(k) = 0.0
+                inflow_damping_factor(k) = 0.0_wp
              ENDIF
 
@@ -1235,13 +1235,13 @@
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
-                u  (nzb:nzb_u_inner(j,i),j,i)   = 0.0
-                v  (nzb:nzb_v_inner(j,i),j,i)   = 0.0
-                w  (nzb:nzb_w_inner(j,i),j,i)   = 0.0
-                e  (nzb:nzb_w_inner(j,i),j,i)   = 0.0
-                tu_m(nzb:nzb_u_inner(j,i),j,i)  = 0.0
-                tv_m(nzb:nzb_v_inner(j,i),j,i)  = 0.0
-                tw_m(nzb:nzb_w_inner(j,i),j,i)  = 0.0
-                te_m(nzb:nzb_w_inner(j,i),j,i)  = 0.0
-                tpt_m(nzb:nzb_w_inner(j,i),j,i) = 0.0
+                u  (nzb:nzb_u_inner(j,i),j,i)   = 0.0_wp
+                v  (nzb:nzb_v_inner(j,i),j,i)   = 0.0_wp
+                w  (nzb:nzb_w_inner(j,i),j,i)   = 0.0_wp
+                e  (nzb:nzb_w_inner(j,i),j,i)   = 0.0_wp
+                tu_m(nzb:nzb_u_inner(j,i),j,i)  = 0.0_wp
+                tv_m(nzb:nzb_v_inner(j,i),j,i)  = 0.0_wp
+                tw_m(nzb:nzb_w_inner(j,i),j,i)  = 0.0_wp
+                te_m(nzb:nzb_w_inner(j,i),j,i)  = 0.0_wp
+                tpt_m(nzb:nzb_w_inner(j,i),j,i) = 0.0_wp
              ENDDO
           ENDDO
@@ -1272,14 +1272,14 @@
 !--    have to be predefined here because they are used (but multiplied with 0)
 !--    there before they are set. 
-       te_m = 0.0; tpt_m = 0.0; tu_m = 0.0; tv_m = 0.0; tw_m = 0.0
+       te_m = 0.0_wp; tpt_m = 0.0_wp; tu_m = 0.0_wp; tv_m = 0.0_wp; tw_m = 0.0_wp
        IF ( humidity  .OR.  passive_scalar )  THEN
-          tq_m = 0.0
+          tq_m = 0.0_wp
           IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
                precipitation )  THEN
-             tqr_m = 0.0
-             tnr_m = 0.0
-          ENDIF
-       ENDIF
-       IF ( ocean )  tsa_m = 0.0
+             tqr_m = 0.0_wp
+             tnr_m = 0.0_wp
+          ENDIF
+       ENDIF
+       IF ( ocean )  tsa_m = 0.0_wp
 
     ELSE
@@ -1323,6 +1323,6 @@
        IF ( use_prescribed_profile_data )  THEN
 
-          volume_flow_initial_l = 0.0
-          volume_flow_area_l    = 0.0
+          volume_flow_initial_l = 0.0_wp
+          volume_flow_area_l    = 0.0_wp
 
           IF ( nxr == nx )  THEN
@@ -1359,6 +1359,6 @@
        ELSEIF ( TRIM( initializing_actions ) == 'cyclic_fill' )  THEN
 
-          volume_flow_initial_l = 0.0
-          volume_flow_area_l    = 0.0
+          volume_flow_initial_l = 0.0_wp
+          volume_flow_area_l    = 0.0_wp
 
           IF ( nxr == nx )  THEN
@@ -1395,6 +1395,6 @@
        ELSEIF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
 
-          volume_flow_initial_l = 0.0
-          volume_flow_area_l    = 0.0
+          volume_flow_initial_l = 0.0_wp
+          volume_flow_area_l    = 0.0_wp
 
           IF ( nxr == nx )  THEN
@@ -1513,5 +1513,5 @@
           DO  j = nys, nyn
              DO  k = nzb, nzt+1 
-                IF ( lad_s(k,j,i) > 0.0 )  THEN
+                IF ( lad_s(k,j,i) > 0.0_wp )  THEN
                    lad_u(k,j,i)   = lad_s(k,j,i) 
                    lad_u(k,j,i+1) = lad_s(k,j,i)
@@ -1521,10 +1521,10 @@
              ENDDO
              DO  k = nzb, nzt
-                lad_w(k,j,i) = 0.5 * ( lad_s(k+1,j,i) + lad_s(k,j,i) )
+                lad_w(k,j,i) = 0.5_wp * ( lad_s(k+1,j,i) + lad_s(k,j,i) )
              ENDDO
           ENDDO
        ENDDO
 
-       lad_w(pch_index,:,:) = 0.0
+       lad_w(pch_index,:,:) = 0.0_wp
        lad_w(nzt+1,:,:)     = lad_w(nzt,:,:)
 
@@ -1535,17 +1535,17 @@
 !
 !--    Initialisation of the canopy heat source distribution
-       IF ( cthf /= 0.0 )  THEN
+       IF ( cthf /= 0.0_wp )  THEN
 !
 !--       Piecewise evaluation of the leaf area index by 
 !--       integration of the leaf area density
-          lai(:,:,:) = 0.0
+          lai(:,:,:) = 0.0_wp
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
                 DO  k = pch_index-1, 0, -1
                    lai(k,j,i) = lai(k+1,j,i) +                   &
-                                ( 0.5 * ( lad_w(k+1,j,i) +       &
+                                ( 0.5_wp * ( lad_w(k+1,j,i) +    &
                                           lad_s(k+1,j,i) ) *     &
                                   ( zw(k+1) - zu(k+1) ) )  +     &
-                                ( 0.5 * ( lad_w(k,j,i)   +       &
+                                ( 0.5_wp * ( lad_w(k,j,i)   +    &
                                           lad_s(k+1,j,i) ) *     &
                                   ( zu(k+1) - zw(k) ) )
@@ -1561,5 +1561,5 @@
                 DO  k = 0, pch_index
                    canopy_heat_flux(k,j,i) = cthf *                    &
-                                             exp( -0.6 * lai(k,j,i) )
+                                             exp( -0.6_wp * lai(k,j,i) )
                 ENDDO
              ENDDO
@@ -1577,5 +1577,5 @@
 !
 !-- If required, initialize dvrp-software
-    IF ( dt_dvrp /= 9999999.9 )  CALL init_dvrp
+    IF ( dt_dvrp /= 9999999.9_wp )  CALL init_dvrp
 
     IF ( ocean )  THEN
@@ -1624,6 +1624,6 @@
     ELSE                                     ! for Euler-method
 
-       weight_substep(1) = 1.0      
-       weight_pres(1)    = 1.0                   
+       weight_substep(1) = 1.0_wp      
+       weight_pres(1)    = 1.0_wp                   
 
     ENDIF
@@ -1631,13 +1631,13 @@
 !
 !-- Initialize Rayleigh damping factors
-    rdf    = 0.0
-    rdf_sc = 0.0
-    IF ( rayleigh_damping_factor /= 0.0 )  THEN
+    rdf    = 0.0_wp
+    rdf_sc = 0.0_wp
+    IF ( rayleigh_damping_factor /= 0.0_wp )  THEN
        IF ( .NOT. ocean )  THEN
           DO  k = nzb+1, nzt
              IF ( zu(k) >= rayleigh_damping_height )  THEN
                 rdf(k) = rayleigh_damping_factor * &
-                      ( SIN( pi * 0.5 * ( zu(k) - rayleigh_damping_height )    &
-                                      / ( zu(nzt) - rayleigh_damping_height ) )&
+                      ( SIN( pi * 0.5_wp * ( zu(k) - rayleigh_damping_height ) &
+                                         / ( zu(nzt) - rayleigh_damping_height ) )&
                       )**2
              ENDIF
@@ -1647,6 +1647,6 @@
              IF ( zu(k) <= rayleigh_damping_height )  THEN
                 rdf(k) = rayleigh_damping_factor * &
-                      ( SIN( pi * 0.5 * ( rayleigh_damping_height - zu(k) )    &
-                                      / ( rayleigh_damping_height - zu(nzb+1)))&
+                      ( SIN( pi * 0.5_wp * ( rayleigh_damping_height - zu(k) ) &
+                                         / ( rayleigh_damping_height - zu(nzb+1)))&
                       )**2
              ENDIF
@@ -1659,5 +1659,5 @@
 !-- Initialize the starting level and the vertical smoothing factor used for 
 !-- the external pressure gradient
-    dp_smooth_factor = 1.0
+    dp_smooth_factor = 1.0_wp
     IF ( dp_external )  THEN
 !
@@ -1670,9 +1670,9 @@
        ENDIF
        IF ( dp_smooth )  THEN
-          dp_smooth_factor(:dp_level_ind_b) = 0.0
+          dp_smooth_factor(:dp_level_ind_b) = 0.0_wp
           DO  k = dp_level_ind_b+1, nzt
-             dp_smooth_factor(k) = 0.5 * ( 1.0 + SIN( pi * &
-                  ( REAL( k - dp_level_ind_b, KIND=wp ) /  &
-                    REAL( nzt - dp_level_ind_b, KIND=wp ) - 0.5 ) ) )
+             dp_smooth_factor(k) = 0.5_wp * ( 1.0_wp + SIN( pi *               &
+                        ( REAL( k - dp_level_ind_b, KIND=wp ) /                &
+                          REAL( nzt - dp_level_ind_b, KIND=wp ) - 0.5_wp ) ) )
           ENDDO
        ENDIF
@@ -1683,12 +1683,12 @@
 !-- non-cyclic lateral boundaries. The damping zone has the maximum value 
 !-- at the inflow boundary and decreases to zero at pt_damping_width.
-    ptdf_x = 0.0
-    ptdf_y = 0.0
+    ptdf_x = 0.0_wp
+    ptdf_y = 0.0_wp
     IF ( bc_lr_dirrad )  THEN
        DO  i = nxl, nxr
           IF ( ( i * dx ) < pt_damping_width )  THEN
-             ptdf_x(i) = pt_damping_factor * ( SIN( pi * 0.5 *              &
-                         REAL( pt_damping_width - i * dx, KIND=wp ) / (                 &
-                         REAL( pt_damping_width, KIND=wp )            ) ) )**2 
+             ptdf_x(i) = pt_damping_factor * ( SIN( pi * 0.5_wp *              &
+                            REAL( pt_damping_width - i * dx, KIND=wp ) / (     &
+                            REAL( pt_damping_width, KIND=wp )            ) ) )**2 
           ENDIF
        ENDDO
@@ -1697,7 +1697,7 @@
           IF ( ( i * dx ) > ( nx * dx - pt_damping_width ) )  THEN
              ptdf_x(i) = pt_damping_factor *                                   &
-                         SIN( pi * 0.5 *                                       &
-                              ( ( i - nx ) * dx + pt_damping_width ) /         &
-                              REAL( pt_damping_width, KIND=wp ) )**2
+                         SIN( pi * 0.5_wp *                                    &
+                                 ( ( i - nx ) * dx + pt_damping_width ) /      &
+                                 REAL( pt_damping_width, KIND=wp ) )**2
           ENDIF
        ENDDO 
@@ -1706,7 +1706,7 @@
           IF ( ( j * dy ) > ( ny * dy - pt_damping_width ) )  THEN
              ptdf_y(j) = pt_damping_factor *                                   &
-                         SIN( pi * 0.5 *                                       &
-                              ( ( j - ny ) * dy + pt_damping_width ) /         &
-                              REAL( pt_damping_width, KIND=wp ) )**2
+                         SIN( pi * 0.5_wp *                                    &
+                                 ( ( j - ny ) * dy + pt_damping_width ) /      &
+                                 REAL( pt_damping_width, KIND=wp ) )**2
           ENDIF
        ENDDO 
@@ -1715,7 +1715,7 @@
           IF ( ( j * dy ) < pt_damping_width )  THEN
              ptdf_y(j) = pt_damping_factor *                                   &
-                         SIN( pi * 0.5 *                                       &
-                             ( pt_damping_width - j * dy ) /                   &
-                             REAL( pt_damping_width, KIND=wp ) )**2
+                         SIN( pi * 0.5_wp *                                    &
+                                ( pt_damping_width - j * dy ) /                &
+                                REAL( pt_damping_width, KIND=wp ) )**2
           ENDIF
        ENDDO
@@ -1727,9 +1727,9 @@
 !-- are called from flow_statistics (or - depending on the chosen model run -
 !-- are never initialized)
-    sums_divnew_l      = 0.0
-    sums_divold_l      = 0.0
-    sums_l_l           = 0.0
-    sums_up_fraction_l = 0.0
-    sums_wsts_bc_l     = 0.0
+    sums_divnew_l      = 0.0_wp
+    sums_divold_l      = 0.0_wp
+    sums_l_l           = 0.0_wp
+    sums_up_fraction_l = 0.0_wp
+    sums_wsts_bc_l     = 0.0_wp
 
 !
@@ -1737,7 +1737,7 @@
 !-- Ghost points are excluded because counting values at the ghost boundaries
 !-- would bias the statistics
-    rmask = 1.0
-    rmask(:,nxlg:nxl-1,:) = 0.0;  rmask(:,nxr+1:nxrg,:) = 0.0
-    rmask(nysg:nys-1,:,:) = 0.0;  rmask(nyn+1:nyng,:,:) = 0.0
+    rmask = 1.0_wp
+    rmask(:,nxlg:nxl-1,:) = 0.0_wp;  rmask(:,nxr+1:nxrg,:) = 0.0_wp
+    rmask(nysg:nys-1,:,:) = 0.0_wp;  rmask(nyn+1:nyng,:,:) = 0.0_wp
 
 !
@@ -1769,5 +1769,5 @@
     ngp_2dh_l         = 0
     ngp_2dh           = 0
-    ngp_3d_inner_l    = 0.0
+    ngp_3d_inner_l    = 0.0_wp
     ngp_3d_inner      = 0
     ngp_3d            = 0
@@ -1777,5 +1777,5 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             IF ( rmask(j,i,sr) == 1.0 )  THEN
+             IF ( rmask(j,i,sr) == 1.0_wp )  THEN
 !
 !--             All xy-grid points
Index: /palm/trunk/SOURCE/package_parin.f90
===================================================================
--- /palm/trunk/SOURCE/package_parin.f90	(revision 1339)
+++ /palm/trunk/SOURCE/package_parin.f90	(revision 1340)
@@ -20,4 +20,5 @@
 ! Current revisions:
 ! -----------------
+! REAL constants defined as wp-kinds
 !
 ! Former revisions:
@@ -196,5 +197,5 @@
 !-- Default setting of dt_dosp here (instead of check_parameters), because its
 !-- current value is needed in init_pegrid
-    IF ( dt_dosp == 9999999.9 )  dt_dosp = dt_data_output
+    IF ( dt_dosp == 9999999.9_wp )  dt_dosp = dt_data_output
 
  30 CONTINUE
